#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "linkedlist.h"

void	LinkedList_Add(LinkedList*	ll,void* data)
{
	while (ll->data)
	{
		if (ll->next)
		{
			ll=ll->next;
		} else {
			ll->next=malloc(sizeof(LinkedList));
			memset(ll->next,0,sizeof(LinkedList));
		}
	}
	ll->data=data;
}
void	LinkedList_AddInt(LinkedList*	ll,int x)
{
	int * newInt;
	newInt=(int*)malloc(sizeof(int));
	*newInt=x;
	LinkedList_Add(ll,newInt);	
}
void	LinkedList_AddCopyOfString(LinkedList*	ll,char* data)
{
	void	*newStr;
	newStr=malloc(strlen(data)+1);
	strcpy(newStr,data);
	LinkedList_Add(ll,newStr);
}
void*	LinkedList_Get(LinkedList*	ll,int count)
{
	while(count)
	{
		ll=ll->next;
		count--;
	}
	return	ll->data;
}
int LinkedList_GetInt(LinkedList* ll,int count)
{
  int * tmp;
  tmp=LinkedList_Get(ll,count);
  return *tmp;
}

int	LinkedList_Count(LinkedList*	ll)
{
	int count=1;
	if ((!ll->data) && (!ll->next))
	{
		return	0;
	}
	while(ll->next)
	{
		count++;
		ll=ll->next;
	}
	return	count;
}
void	LinkedList_Init(LinkedList*	ll)
{
	ll->data=0;
	ll->next=0;
}

// NEVER pass anything but the root node to this function
void	LinkedList_Clear(LinkedList*	ll)
{
	LinkedList*	last;
	LinkedList*	first=ll;
	while(ll)
	{
		if (ll->data)
		{
			free(ll->data);
			ll->data=0;
		}
		last=ll;
		ll=ll->next;
		if (last!=first)
		{
			free(last);
		} else {
			last->next=0;
		}
	}
}

void	LinkedList_Remove(LinkedList*	ll,int count)
{
	LinkedList*	last;
	LinkedList*	rm;
	if (!count)
	{
		// the first item cannot be removed, so we have a special case for this
		free(ll->data);
		if (ll->next)
		{
			// get the next one
			rm=ll->next;
			// get it's contents
			ll->data=ll->next->data;
			ll->next=ll->next->next;
			// remove the next one
			free(rm);
		} else {
			ll->data=0;
		}
	} else {
		// first get the item we want to remove
		while(count)
		{
			last=ll;
			ll=ll->next;
			count--;
		}
		// this is not the first item, so just remove it
		last->next=ll->next;
		free(ll->data);
		free(ll);
	}
}

int	LinkedList_Find(LinkedList*	ll,void * fval)
{
	int amount=LinkedList_Count(ll);
	int count;
	for (count=0;count<amount;count++)
	{
		if (LinkedList_Get(ll,count)==fval)
		{
			return	count;
		}
	}
	return -1;
}

int   LinkedList_FindInt(LinkedList*   ll,int fval)
{
	int amount=LinkedList_Count(ll);
	int count;
   int * fp;
	for (count=0;count<amount;count++)
	{
      fp=LinkedList_Get(ll,count);
      if (*fp==fval)
		{
			return	count;
		}
	}
	return -1;
}
