#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "rune.h"
#include "linkedlist.h"

// add questionmark as specialhandling or as partword
// add command,dot and separators for special handling
// add " for special handling(completeword)

// weight less used and words with few references
// in usage when replying

// for building meanings try to select words with many crossrefs

// add smileys for mood?

LINKEDLIST(words);

void (*rune_output)(char *);
int   numLineInWords;
int   lineInWords[10000];
int   numLineOutWords;
int   lineOutWords[10000];

typedef struct tagRefStat {
  int word;
  int numHits;
}RefStat;

RefStat * rune_addRef(LinkedList * ll,int i)
{
  RefStat* rs;
  rs=malloc(sizeof(RefStat));
  rs->word=i;
  rs->numHits=0;
  LinkedList_Add(ll,rs);

  return rs;
}
RefStat * rune_addRefHits(LinkedList * ll,int i,int hits)
{
  RefStat* rs;
  rs=malloc(sizeof(RefStat));
  rs->word=i;
  rs->numHits=hits;
  LinkedList_Add(ll,rs);

  return rs;
}

int rune_findRefWord(LinkedList * ll,int num)
{
  int n;
  int i;
  RefStat* rs;
  n=LinkedList_Count(ll);
  for (i=0;i<n;i++)
  {
    rs=LinkedList_Get(ll,i);
    if (rs->word==num)
    {
      return i;
    }
  }
  return -1;
}

void rune_addHit(LinkedList * ll,int i)
{
  RefStat* rs;
  int idx=rune_findRefWord(ll,i);
  rs=LinkedList_Get(ll,idx);
  rs->numHits++;
}

int rune_checkHits(LinkedList * ll,int i)
{
  RefStat* rs;
  rs=LinkedList_Get(ll,rune_findRefWord(ll,i));
  return rs->numHits;
}

typedef struct tagWord {
  int numHits;
  char * word;
  LinkedList   referencesData;
  LinkedList   *references;     // words connected
  LinkedList   syntaxPreData;
  LinkedList   *syntaxPre;     // words that preceeds this
  LinkedList   syntaxPostData;
  LinkedList   *syntaxPost;     // words that copes after this
}Word;

#define rune_getStrongestReferenceWord(x)  rune_getStrongestRefWord(((Word*)(x))->references)
#define rune_getStrongestPreWord(x)  rune_getStrongestRefPrePostWord(((Word*)(x))->references,((Word*)(x))->syntaxPre)
#define rune_getStrongestPostWord(x)  rune_getStrongestRefPrePostWord(((Word*)(x))->references,((Word*)(x))->syntaxPost)

int rune_getStrongestRefPrePostWord(LinkedList* ref,LinkedList * ll)
{
  RefStat* rs;
  Word* tmpWord;
  int n,o;
  int i,j;
  int strength=0;
  int testStrength;
  int idx=-1;
  int rVal,rVal2;
  n=LinkedList_Count(ll);
  for (i=0;i<n;i++)
  {
     rVal=(rand()&0xff)+0x110;
     rs=LinkedList_Get(ll,i);
     if (rs->word!=-1)
     {
       tmpWord=LinkedList_Get(words,rs->word);
       testStrength=((tmpWord->numHits+(rs->numHits*50))*rVal);
       for (j=0;j<numLineInWords;j++)
       {
         rVal2=(rand()&0x3f)+0x40;
         if (-1==rune_findRefWord(tmpWord->references,lineInWords[i]))
         {
           testStrength-=(((testStrength*6)/100)*rVal2)/0x40;
         } else {
           testStrength+=(((testStrength*30)/97)*rVal2)/0x40;
         }
       }
       if (strength<testStrength)
       {
         idx=rs->word;
         strength=testStrength;
       }
     } else {
       testStrength=(rs->numHits*45)*rVal;
       if (strength<testStrength)
       {
         idx=rs->word;
         strength=testStrength;
       }
     }
  }
  return idx;
}
int rune_getStrongestRefWord(LinkedList * ll)
{
  RefStat* rs;
  Word* tmpWord;
  int n;
  int i;
  int j;
  int strength=0;
  int rVal;
  int rVal2;
  int testStrength;
  int idx=-1;
  n=LinkedList_Count(ll);
  for (i=0;i<n;i++)
  {
	  rVal=(rand()&0xff)+0x120;
     rs=LinkedList_Get(ll,i);
     if (rs->word!=-1)
     {
       tmpWord=LinkedList_Get(words,rs->word);
       testStrength=(tmpWord->numHits+(rs->numHits*50))*rVal;
       for (j=0;j<numLineInWords;j++)
       {
         rVal2=(rand()&0x3f)+0x40;
         if (-1==rune_findRefWord(tmpWord->references,lineInWords[i]))
         {
           testStrength-=(((testStrength*6)/100)*rVal2)/0x40;
         } else {
           testStrength+=(((testStrength*30)/97)*rVal2)/0x40;
         }
       }
       if (strength<testStrength)
       {
         idx=rs->word;
         strength=testStrength;
       }
     } else {
       testStrength=(rs->numHits*45)*rVal;
       if (strength<testStrength)
       {
         idx=rs->word;
         strength=testStrength;
       }
     }
  }
  return idx;
}

int rune_findword(char * in)
{
   int i;
   int n;
   Word* tmpO;
   n=LinkedList_Count(words);
   for (i=0;i<n;i++)
   {
     tmpO=LinkedList_Get(words,i);
     if (!stricmp(tmpO->word,in))
     {
       break;
     }
   }
   if (i==n)
     return -1;
   printf("found");
   return i;
}

void rune_handleword(char * in)
{
  int exists;
  Word*   word;
  printf("handle\n");
  exists=rune_findword(in);
  if (exists==-1)
  {
    word=malloc(sizeof(Word));
    memset(word,0,sizeof(Word));
    word->word=malloc(strlen(in)+3);
    strcpy(word->word,in);
    word->numHits=0;
    word->syntaxPre=&word->syntaxPreData;
    word->syntaxPost=&word->syntaxPostData;
    word->references=&word->referencesData;
    LinkedList_Init(word->syntaxPre);
    LinkedList_Init(word->syntaxPost);
    LinkedList_Init(word->references);
    LinkedList_Add(words,word);
    exists=LinkedList_Find(words,word);
  }
  // add word to list
  lineInWords[numLineInWords]=exists;
  numLineInWords++;
//  LinkedList_AddCopyOfString(words,in);
}

void rune_managewords()
{
  int i,j;
  int tmpInt;
  int relevance;
  int prev,next;
  int dbWords;

  Word* thisWord;
  Word* otherWord;
  RefStat* rs;

  int numOutTempWords;
  int outTempWords[3000];

  // feed database

  for (i=0;i<numLineInWords;i++)
  {
    thisWord=LinkedList_Get(words,lineInWords[i]);
    thisWord->numHits++;

    prev=(i==0)?-1:lineInWords[i-1];
    next=(i==(numLineInWords-1))?-1:lineInWords[i+1];
//    printf("%i %i\n",prev,next);
    if (-1==rune_findRefWord(thisWord->syntaxPre,prev))
    {
      rune_addRef(thisWord->syntaxPre,prev);
    }
    rune_addHit(thisWord->syntaxPre,prev);

    if (-1==rune_findRefWord(thisWord->syntaxPost,next))
    {
      rune_addRef(thisWord->syntaxPost,next);
    }
    rune_addHit(thisWord->syntaxPost,next);

    for (j=i+1;j<numLineInWords;j++)
    {
      // add reference to this
      if (-1==rune_findRefWord(thisWord->references,lineInWords[j]))
      {
        rune_addRef(thisWord->references,lineInWords[j]);
      }
      rune_addHit(thisWord->references,lineInWords[j]);

      // add reference to other
      otherWord=LinkedList_Get(words,lineInWords[j]);
      if (-1==rune_findRefWord(otherWord->references,lineInWords[i]))
      {
        rune_addRef(otherWord->references,lineInWords[i]);
      }
      rune_addHit(otherWord->references,lineInWords[i]);
    }
  }

  // build new words

  relevance=300000000;
  tmpInt=-1;
  for (i=0;i<numLineInWords;i++)
  {
    thisWord=LinkedList_Get(words,lineInWords[i]);
    if (thisWord->numHits<relevance)
    {
      relevance=thisWord->numHits;
      tmpInt=lineInWords[i];
    }
//    printf("");
  }

  if (tmpInt==-1)
  {
    numLineOutWords=0;
//    lineOutWords[0]=0;
    return;
  }

  // build start of meaning
  numOutTempWords=0;
  outTempWords[numOutTempWords++]=tmpInt;

  prev=rune_getStrongestPreWord(LinkedList_Get(words,tmpInt));
  while((prev!=-1) && (numOutTempWords<10))
  {
    tmpInt=0;
    for (j=0;j<numOutTempWords;j++)
    {
      if (outTempWords[j]==prev)
      {
        thisWord=LinkedList_Get(words,prev);
        printf("repeat beg:%s\n",thisWord->word);
        tmpInt=1;
      }
    }
    if (tmpInt==1)
      break;
    outTempWords[numOutTempWords++]=prev;
    prev=rune_getStrongestPreWord(LinkedList_Get(words,prev));
  }
  // meaning built. reverse it and copy to out
  for (i=0;i<numOutTempWords;i++)
  {
    lineOutWords[i]=outTempWords[numOutTempWords-i-1];
//    lineOutWords[i]=outTempWords[i];
  }
  numLineOutWords=numOutTempWords;

  // ok do end of meaning
  next=rune_getStrongestReferenceWord(LinkedList_Get(words,lineOutWords[0]));
  while((next!=-1) && (numLineOutWords<16))
  {
    tmpInt=0;
    for (j=0;j<numLineOutWords;j++)
    {
      if (lineOutWords[j]==next)
      {
        thisWord=LinkedList_Get(words,next);
        printf("repeat post:%s\n",thisWord->word);
        tmpInt=1;
      }
    }
    if (tmpInt==1)
      break;
    lineOutWords[numLineOutWords++]=next;
    next=rune_getStrongestPostWord(LinkedList_Get(words,next));
  }


/*  numLineOutWords=(rand()*9)/RAND_MAX;

  dbWords=LinkedList_Count(words);

  for (i=0;i<numLineOutWords;i++)
  {
    lineOutWords[i]=(rand()*dbWords)/RAND_MAX;
    if (lineOutWords[i]>=dbWords) lineOutWords[i]=0;
  }*/
}

void rune_readRefList(FILE* f,LinkedList* ref)
{
   int i;
   int n;
   int tmp,tmp2;
   fscanf(f,"%i",&n);
   for (i=0;i<n;i++)
   {
     fscanf(f,"%i %i",&tmp,&tmp2);
//     LinkedListAddInt(ref,tmp);
     rune_addRefHits(ref,tmp,tmp2);
   }
}

void rune_writeRefList(FILE* f,LinkedList* ref)
{
   int i;
   int n;
   int tmp;
   RefStat* rs;
   n=LinkedList_Count(ref);
   fprintf(f,"%i",n);
   for (i=0;i<n;i++)
   {
//     tmp=LinkedList_GetInt(ref,i);
     rs=LinkedList_Get(ref,i);
     fprintf(f,"  %i %i",rs->word,rs->numHits);
   }
   fprintf(f,"\n");
}

Word * rune_readWord(FILE * f)
{
  Word * word;
  char tmpStr[4000];

  word=malloc(sizeof(Word));
  memset(word,0,sizeof(Word));

  fscanf(f,"%s",tmpStr);

  word->word=malloc(strlen(tmpStr)+3);
  strcpy(word->word,tmpStr);

  fscanf(f,"%i",&word->numHits);

  word->syntaxPre=&word->syntaxPreData;
  word->syntaxPost=&word->syntaxPostData;
  word->references=&word->referencesData;
  LinkedList_Init(word->syntaxPre);
  LinkedList_Init(word->syntaxPost);
  LinkedList_Init(word->references);

  rune_readRefList(f,word->references);
  rune_readRefList(f,word->syntaxPre);
  rune_readRefList(f,word->syntaxPost);

  return word;
}

void rune_writeWord(FILE * f,Word * word)
{
  fprintf(f,"%s ",word->word);

  free(word->word);

//  word=malloc(sizeof(Word));
//  memset(word,0,sizeof(Word));

//  word->word=malloc(strlen(tmpStr)+3);
//  strcpy(word->word,tmpStr);

  fprintf(f,"%i\n",word->numHits);

  rune_writeRefList(f,word->references);
  rune_writeRefList(f,word->syntaxPre);
  rune_writeRefList(f,word->syntaxPost);

  LinkedList_Clear(word->syntaxPre);
  LinkedList_Clear(word->syntaxPost);
  LinkedList_Clear(word->references);

}

void rune_init()
{
  time_t tim;
  FILE * f;

  int numFileWords;
  int i;

  tim=time(0);
  srand(tim);

  LinkedList_Init(words);
  // load database
  f=fopen("rune.txt","rt");
  if (f)
  {
    fscanf(f,"%i",&numFileWords);
    for (i=0;i<numFileWords;i++)
    {
      LinkedList_Add(words,rune_readWord(f));
    }
    fclose(f);
  }
}

void rune_deinit()
{
  FILE * f;
  Word * tmpO;

  int i;
  int n;
  // save database
  f=fopen("rune.txt","wt");
  n=LinkedList_Count(words);
  fprintf(f,"%i\n",n);
  for (i=0;i<n;i++)
  {
    tmpO=LinkedList_Get(words,i);
    rune_writeWord(f,tmpO);
  }
  fclose(f);
}

void rune_input(char * in)
{
  char word[40000];
  char output[40000];
  Word* tmpO;
  int sp=0;
  int ip=0;
  int op=0;

  int i,n;

  numLineInWords=0;

  while(1)
  {
    if (!in[ip])
    {
      if (op-sp)
      {
        memcpy(word,&in[sp],op-sp);
        word[op-sp]=0;
        printf("%s %i\n",word,op-sp);
        rune_handleword(word);
      }
      break;
    }
    switch(in[ip])
    {
    case '<' :
    case '>' :
    case ')' :
    case '(' :
    case '.' :
    case ',' :
    case '?' :
    case '-' :
    case '"' :
    case ' ' :
      if (op-sp)
      {
        memcpy(word,&in[sp],op-sp);
        word[op-sp]=0;
        rune_handleword(word);
      }
      if (in[ip]=='?')
      {
        word[0]='?';
        word[1]=0;
        rune_handleword(word);
      }
      sp=op+1;
      break;
    }
    op++;
    ip++;
  }

  rune_managewords();

/*
  strcpy(output,"'");
  n=LinkedList_Count(words);
  for (i=0;i<n;i++)
  {
    tmpO=LinkedList_Get(words,i);
    strcat(output,tmpO->word);
    strcat(output,"','");
  }
*/
  strcpy(output,"");
  for (i=0;i<numLineOutWords;i++)
  {
    tmpO=LinkedList_Get(words,lineOutWords[i]);
    strcat(output,tmpO->word);
    strcat(output," ");
  }
  rune_output(output);
}
